#!/usr/bin/perl

use strict;
#use warnings;

	main();

sub main()
{
	# quit unless we have the correct number of command-line args
	if (@ARGV != 2)
	{
		print "\nUsage: $0 vcfFile consensusFile\n";
		exit;
	}
	my $vcfFile = $ARGV[0];
	my $consFile = $ARGV[1];
	my $threshold;

	my $rccFile = "rcc.txt";

	my %opts = (d=>3, D=>100000, Q=>10, l=>5); # d=>3 ----> d=>10
	
	my $_Q = $opts{Q};
  	my $_d = $opts{d};
  	my $_D = $opts{D};

	my %het = (AC=>'M', AG=>'R', AT=>'W', CA=>'M', CG=>'S', CT=>'Y',
                   GA=>'R', GC=>'S', GT=>'K', TA=>'W', TC=>'Y', TG=>'K');

	my ($line, $nextLine);
	my @check;
	my ($i, $j, $k);
	my (@t, @t1);
	my ($prevChr, $prevPos);
	my $indelNum = 0;

	my @t = split(/\./, $vcfFile);
	my $vcfTemp = $t[0]."_Temp.vcf";

	##### for testing #####

	my @ttt;
	my $snpNum = 0;	
	my $_avgDP = 0;
	my $_avgQUAL = 0;
	my $_diffCtg = 0;

	#######################

	open FILEIN, "< $vcfFile" or die "$vcfFile: $!\n";
	open FILEIN2, "< $rccFile" or die "$rccFile: $!\n";
	open FILEOUT, "> $vcfTemp" or die "$vcfTemp: $!\n";

	print "Started at ".localtime."\n";
	
	
	$threshold = <FILEIN2>;	
	$_diffCtg = <FILEIN2>;
	#$_diffCtg *= -1;
	#$_diffCtg += <FILEIN2>;	
	close FILEIN2;

	while ($line = <FILEIN>)
	{
		next if ($line =~ /^#/);

		@t = split(" ", $line);
		############################
		$_avgDP += $1 if ($t[7] =~ /DP=(\d+)/);
		$_avgQUAL += $t[5];
		$snpNum++;
		############################
	}
	close FILEIN;

	#############################
	$_avgDP /= $snpNum;
	$_avgQUAL /= $snpNum;
	#############################

	open FILEIN, "< $vcfFile" or die "$vcfFile: $!\n";

	while ($line = <FILEIN>)
	{
		next if ($line =~ /^#/);
		last;
	}

	while (defined $line)
	{	
		@t = split(" ", $line);

		@check = ();
		push (@check, $line);
		
		$nextLine = <FILEIN>;
		while(1)
		{
			@t1 = split(" ", $nextLine);

			if($t1[1] != $t[1]) #check positions
			{
				last;
			}
			push (@check, $nextLine);
			$nextLine = <FILEIN>;
			
		}

		$k = selecting (\@check, $_d, $_avgQUAL, $threshold);
#		$k = 0;
		$indelNum++ if ($k > 0);
		print FILEOUT $check[$k];
		
		$line = $nextLine;
	}
	close FILEIN;
	close FILEOUT;

	#print "Indel Number: $indelNum\n";

	open FILEIN, "< $vcfTemp" or die "$vcfTemp: $!\n";
	open FILEOUT, "> $consFile" or die "$consFile: $!\n";

	$prevChr = '';
	$line = <FILEIN>;
	while(defined $line)
	{
		@t = split(" ", $line); 

		if ($prevChr ne $t[0])
		{
			if ($prevChr)
			{
				@t1 = split(/\:/, $prevChr);
				my ($fPos, $ePos) = split (/\-/, $t1[1]);
				$k = ($ePos - $fPos + 1) - $prevPos;
				for($i = 0; $i < $k; $i++)
				{
					print FILEOUT "n";
				}
				#print (($ePos - $fPos) - $prevPos)." \n"; 
				print FILEOUT "\n";
			}

			print FILEOUT ">$t[0] \n";
			($prevChr, $prevPos) = ($t[0], 0);
		}

		$k = $t[1] - $prevPos;
		for($i = 1; $i < $k; $i++)
		{
			print FILEOUT "n";
		}
 
		if (length($t[3]) == 1 && $t[7] !~ /INDEL/ && $t[4] =~ /^([A-Za-z.])(,[A-Za-z])*$/) # a SNP or reference
		{ 
	        	my ($ref, $alt) = ($t[3], $1);
	      		my ($b, $q);
			###
			my $dp;
			###
	      		$q = $1 if ($t[7] =~ /FQ=(-?[\d\.]+)/);

	      		if ($q < 0) 
			{
				$_ = ($t[7] =~ /AF1=([\d\.]+)/)? $1 : 0;
				####
				$dp = ($t[7] =~ /DP=(\d+)/) ? $1 : 0;
				####
				if ($_diffCtg < 15)
				{
					$b = ($_ < .5 || $alt eq '.' || $dp < $_d)? $ref : $alt; 
				}
				else
				{
					$b = ($_ < .5 || $alt eq '.' || $dp < $_d || (($t[3] eq 'n' || $t[3] eq 'N') && $t[5] < $_avgQUAL))? $ref : $alt;
				}
				
				
			

				$q = -$q;
			} 
			else 
			{
				$b = $het{"$ref$alt"};
				$b ||= 'N';
			}
	      		$b = lc($b);
	      		$b = uc($b) if (($t[7] =~ /MQ=(\d+)/ && $1 >= $_Q) && ($t[7] =~ /DP=(\d+)/ && $1 >= $_d && $1 <= $_D));

			print FILEOUT $b;
		} 
		elsif ($t[4] ne '.') # an INDEL
		{
			my @t4 =  split(",", $t[4]); # for getting the first one from a multi options
			$t[4] = $t4[0];
			
			##############################
			my $len = @t4;
			if ($len > 1) 
			{ 
				$t[4] = $t4[1]; #??????????????????
			}
			###############################
			
			
			if (length($t[3]) < length($t[4])) # an insertion
			{
	      			print FILEOUT substr ($t[4], 0, length($t[4]) - length($t[3]) + 1);
			}
			else # a deletion
			{
				my $t4_len = 0;
				if ($t[4] ne '.')
				{
					$t4_len = length($t[4]);
				}
				
				print FILEOUT substr ($t[4], 0, length($t[3]) - $t4_len);
				for ($i = 0; $i < length($t[3]) - $t4_len; $i++)
				{
					$line = <FILEIN>;
				}
				@t = split(" ", $line);
			}
		}

		$prevPos = $t[1];
		$line = <FILEIN>;
	}
	close FILEIN;
	close FILEOUT;

	print "Finished at ".localtime."\n";	
}

sub selecting ()
{
	my $checkRef = shift;
	my $_d = shift;
	my $_avg = shift;
	my $threshold = shift;
	my $frac = 0; 
	my @t;
	my $qual_mm;

	@t = split(" ", $$checkRef[0]);
	$qual_mm = $t[5];

	#Checking 
	#         QUAL (phred-scale quality) && 
	#         DP (depth of reads) && 
	#         IMF (fraction of reads supporting indel)
	
	for (my $i = 0; $i < @$checkRef; $i++)
	{
		@t = split(" ", $$checkRef[$i]);

		if ($t[7] =~ /INDEL/ && ($t[7] =~ /DP=(\d+)/ && $1 >= 10)) #---  $1 >= $_d
		{
			if ($t[1] > $threshold && $t[3] ne 'n' && 
                            $t[5] > $qual_mm && $t[5] > $_avg)
			{
				$frac = $1 if ($t[7] =~ /IMF=([\d\.]+)/);
				if ($frac > 0.8) # 0.9 --> 0.8
				{
					return $i;
				}
			}
		}
	}

	return 0; 
}



