#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>
#include <ctime>

using namespace std;

const string WHITESPACE = " \t\f\v\n\r";

void convert (char*, char*);
inline string endTrim (const string &);
//////////////////////////////////////

int main(int argc, char *argv[])
{
	if (argc < 3) 
	{
		cerr << "Usage: " << argv[0] <<" "
		     << "consensusFile contigsFile\n";    
		return 1;
	}
	
	char *cnsFile = argv[1];
	char *CntgFile = argv[2];
	
	time_t now = time(0);
	char* dt = ctime(&now);
	cout << "Started at " << dt << "\n";
	
	convert (cnsFile, CntgFile);
	
	now = time(0);
	dt = ctime(&now);
	cout << "Finished at " << dt << "\n";
	
	return 0;
}

void convert (char* cnsFile, char* cntgFile)
{
	ifstream inf(cnsFile);
	if (!inf)
	{
		cerr << cnsFile <<" could not be opened for reading!\n";
		return;
	}

	ofstream outf(cntgFile);
	if (!outf)
	{
		cerr << cntgFile <<" could not be opened for reading!\n";
		return;
	}
	////////////////////////////////////////
	string line;
	string gName;
	string seq;
	int i, k;
	
	while (!inf.eof())
	{
		getline (inf, line);
		gName = endTrim (line);

		getline (inf, line);
		seq = endTrim (line);

		k = 0;
		i = 0;
		while (i < seq.length() && seq[i] == 'N' || seq[i] == 'n')
		{
				i++;
				k++;
		}

		for (; i < seq.length(); i++)
		{
			if (seq[i] == 'N' || seq[i] == 'n')
			{
				outf << gName << ":" << k + 1 << "-" << i << "\n";
				outf << seq.substr (k, i - k) << "\n"; 
				k = i;
			}
			while (i < seq.length() && seq[i] == 'N' || seq[i] == 'n')
			{
				i++;
				k++;
			}
			
			if (i == seq.length())
			{
				break;
			}
		}

		if (k < i)
		{
			outf << gName << ":" << k + 1 << "-" << i << "\n";
			outf << seq.substr (k, i - k) << "\n"; 
		}
	}
	///////////////////////////////////////
	
}

inline string endTrim (const string &t)
{
	string str = t;
	size_t found;
	
	found = str.find_last_not_of(WHITESPACE);
	
	if (found != string::npos)
		str.erase(found + 1);
	else
		str.clear();            // str is all whitespace

    return str;
}
