#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>
#include <ctime>
#include <math.h>

 using namespace std;
 
int main(int argc, char *argv[])
{
	// Check the number of parameters
	if (argc < 2) 
	{
	   // Tell the user how to run the program
	   cerr << "Usage: " << argv[0] <<" "
		   << "GenomeFile" 
		   << std::endl;
	   // "Usage messages" are a conventional way of telling the user
	   // how to run a program if they enter the command incorrectly.
	    
	   return 1;
	}
	
	char *GenomeFile = argv[1];
	
	ifstream inf(GenomeFile);

	if (!inf)
	{
		// Print an error and exit
		cerr << argv[1] <<" could not be opened for reading!" << endl;
		return 1;
	}

	string rcc = "rcc.txt";

	ofstream outf(rcc, ios::app);
	
	if (!outf)
	{
		cerr << rcc <<" could not be opened for writing!" << endl;
		return 1;
	}
	
	
	time_t now = time(0);
	char* dt = ctime(&now);
	//cout << "Started at " << dt << "\n";
	
     	
	string contig = "";
	string line;
	
	int n = 0; 

	while (!inf.eof())
	{
		getline(inf, line);

		if (line.length() == 0) // for the last empty line
			break;

		if (line[0] == '>') n++;				
	}
	
	outf << n;
	outf.close();	

	now = time(0);
	dt = ctime(&now);
	//cout << "Finished at " << dt << "\n";
	return 0;
}
