#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>
#include <ctime>
#include <math.h>

 using namespace std;
 
int main(int argc, char *argv[])
{
	// Check the number of parameters
	if (argc < 3) 
	{
	   // Tell the user how to run the program
	   cerr << "Usage: " << argv[0] <<" "
		   << "GenomeFile GenomeFile2" 
		   << std::endl;
	   // "Usage messages" are a conventional way of telling the user
	   // how to run a program if they enter the command incorrectly.
	    
	   return 1;
	}
	
	char *GenomeFile = argv[1];
	char *CtgFile = argv[2];
	
	
	ifstream inf(GenomeFile);

	// If we couldn't open the input file stream for reading
	if (!inf)
	{
		// Print an error and exit
		cerr << argv[1] <<" could not be opened for reading!" << endl;
		return 1;
	}

	/*
	string CtgFile = "";
	int i = GenomeFile.find_last_of(".");
	if (i != string::npos)
	{
		CtgFile = GenomeFile.substr(0, i);
		CtgFile.append("_n");
		CtgFile.append(GenomeFile.substr(i+1));
	}
	*/

	ofstream outf(CtgFile);
	
	if (!outf)
	{
		cerr << argv[2] <<" could not be opened for writing!" << endl;
		return 1;
	}
	
	// current date/time based on current system
	time_t now = time(0);

	// convert now to string form
	char* dt = ctime(&now);
	//cout << "Started at " << dt << "\n";
	
     	
	string contig = "";
	string line;
	
	int n = 0; 
	getline(inf, line);
 
	if (line[0] == '>')  // for the first contig
	{
		outf << line << "***C" << n + 1 << endl;
	}
	
	while (!inf.eof())
	{
		getline(inf, line);

		if (line.length() == 0) // for the last empty line
			break;

		if (line[0] == '>')
		{
			outf << contig << endl;
			contig = "";
			n++;
			outf << line << "***C" << n + 1 << endl;
			
		}
		else
		{
			contig += line;
		}		
	}
	outf << contig << endl;
	now = time(0);
	dt = ctime(&now);
	//cout << "Finished at " << dt << "\n";
	return 0;
}
