#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>
#include <ctime>
#include <math.h>

using namespace std;

void findPos (string, int&, int&, string&, int&);
 
int main(int argc, char *argv[])
{
	if (argc < 4) 
	{
	   cerr << "Usage: " << argv[0] <<" "
		   << "contigs_exact contigs_UA cns_exact_UA" 
		   << std::endl;
	   return 1;
	}
	
	char *contigs_exact = argv[1];
	char *contigs_UA = argv[2]; 
	char *cns_exact_UA = argv[3];
	int Threshold;

	string rcc = "rcc.txt";
	ifstream infRL(rcc);
	
	if (!infRL)
	{
		cerr << rcc <<" could not be opened for writing!" << endl;
		return 1;
	}
	
	infRL >> Threshold;

	infRL.close();
	
	
	ifstream inf(contigs_exact);

	if (!inf)
	{
		cerr << argv[1] <<" could not be opened for reading!" << endl;
		return 1;
	}
	
	ifstream inf2(contigs_UA);

	if (!inf2)
	{
		cerr << argv[2] <<" could not be opened for reading!" << endl;
		return 1;
	}
	
	ofstream outf(cns_exact_UA);
	
	if (!outf)
	{
		cerr << argv[2] <<" could not be opened for writing!" << endl;
		return 1;
	}
	
	time_t now = time(0);
	char* dt = ctime(&now);
	cout << "Started at " << dt << "\n";
	 
	string line, line2, cns_result;
	
    	string contig_e, contig_UA;
    	string contigName1_e, contigName2_e, contigName_UA;
	string cName1_e, cName2_e, cName_UA;
    	
	int cNum1_e, cNum2_e, cNum_UA;
    	int fPos1_e, fPos2_e, fPos_UA;
    	int ePos1_e, ePos2_e, ePos_UA;
	
	streampos oldpos_e, oldpos_UA;
	
	bool must_read_UA, UAExact, must_read_exact;

	must_read_UA = true;
	must_read_exact = true;

	int counter = 0;
	char ch;
	
	while (!inf.eof()){
		
		cns_result = "";

		if (must_read_exact)
		{
			getline(inf, line);
			contigName1_e = line;
			findPos (contigName1_e, fPos1_e, ePos1_e, cName1_e, cNum1_e);
		}

		if (must_read_UA)
		{
			getline(inf2, line2);
			contigName_UA = line2;
			findPos (contigName_UA, fPos_UA, ePos_UA, cName_UA, cNum_UA);
			getline(inf2, contig_UA);
		}
		
		if (cNum1_e == cNum_UA)
		{
			if (fPos_UA < fPos1_e)
			{
				cns_result += contig_UA.substr(0, fPos1_e - 1);
				must_read_UA = true;
			}
			else 
			{
				must_read_UA = false;
			}
			UAExact = true;
		}
		else
		{
			UAExact = false;
			must_read_UA = false;	
		}
		
		while (!inf.eof())
		{
			counter++;

			if (line.length() == 0) 
				break;
	
			getline(inf, contig_e);
			cns_result += contig_e;
		
			if (!inf.eof())
			{
				getline(inf, line);
				contigName2_e = line;
				findPos (contigName2_e, fPos2_e, ePos2_e, cName2_e, cNum2_e);
			}
			else
			{
				cNum2_e = -1;
			}

			if (cNum1_e != cNum2_e)
			{
				bool flag = false;
				while (cNum1_e != cNum_UA && cNum2_e != cNum_UA)
				{
					if (cNum_UA < cNum2_e)
					{
						outf << cName_UA << "\n";
						outf << contig_UA << "\n";
				
						getline(inf2, line2);
						contigName_UA = line2;
						findPos (contigName_UA, fPos_UA, ePos_UA, cName_UA, cNum_UA);
						getline(inf2, contig_UA);
		
						if (cNum1_e == cNum_UA)
						{
							UAExact = true;
						}
						else
						{
							UAExact = false;
						}
						flag = true;
					}
					else
					{
						getline(inf, contig_e);
						
						outf << cName2_e << "\n";
						outf << contig_e << "\n";

						getline(inf, line);
						contigName2_e = line;
						findPos (contigName2_e, fPos2_e, ePos2_e, cName2_e, cNum2_e);
					}
				}
				
				if (flag)
				{				
					if (UAExact && fPos_UA <= fPos1_e)
					{					
						string temp = contig_UA.substr(0, fPos1_e - 1);
						cns_result = temp + cns_result;
						must_read_UA = true;
					}
					else
					{
						must_read_UA = false;
					}
				}

				if  (must_read_UA)
				{
					getline(inf2, line2);
					contigName_UA = line2;
					findPos (contigName_UA, fPos_UA, ePos_UA, cName_UA, cNum_UA);
					getline(inf2, contig_UA);
			
					if (cNum1_e == cNum_UA)
					{
						UAExact = true;
					}
					else
					{
						UAExact = false;
					}
				}

				if (UAExact && fPos1_e <= fPos_UA)
				{	
					int len = contig_UA.length();
					len -= ePos1_e - fPos_UA + 1;
		
					cns_result += contig_UA.substr(ePos1_e - fPos_UA + 1, len);
					must_read_UA = true;	
				}
				else
				{
					must_read_UA = false;
				}

				must_read_exact = false;
				break;
			}
			
			must_read_exact = true;
			
			if (must_read_UA)
			{

				getline(inf2, line2);
				contigName_UA = line2;
				findPos (contigName_UA, fPos_UA, ePos_UA, cName_UA, cNum_UA);
				getline(inf2, contig_UA);

				if (cNum1_e == cNum_UA)
				{
					UAExact = true;
				}
				else
				{
					UAExact = false;
				}
			}
				
			if (ePos1_e - fPos_UA + 1 == Threshold)
			{
				if ((ePos1_e - fPos_UA + 1) + (fPos2_e - ePos1_e - 1) <= contig_UA.length())
				{
					int len = contig_UA.length();
					len -= ePos1_e - fPos_UA + 1;
					len -= ePos_UA - fPos2_e + 1;
				
					cns_result += contig_UA.substr(ePos1_e - fPos_UA + 1, len);
				}
				else
				{
					for (int k = 0; k < fPos2_e - ePos1_e; k++)
					{
						cns_result += "n";
					}	
				}	
				must_read_UA = true;
			}
			else
			{
				for (int k = 0; k < fPos2_e - ePos1_e - 1; k++)
				{
					cns_result += "n";
				}
				must_read_UA = false;
			}

			fPos1_e = fPos2_e;
			ePos1_e = ePos2_e;
		}
	
		/////////////////////////////////
		outf << cName1_e << "\n";
		outf << cns_result << "\n";

		fPos1_e = fPos2_e;
		ePos1_e = ePos2_e;
		cName1_e = cName2_e;
		cNum1_e = cNum2_e;
		
		/////////////////////////////////
	}
	
	outf.close();
	now = time(0);
	dt = ctime(&now);
	cout << "Finished at " << dt << "\n";
	return 0;
}

void findPos (string cn, int& fP, int& eP, string& cName, int& cNum)
{
	fP = -1;
	eP = -1;
	cNum = -1;
	
	int i, j, k, m;

	k = cn.find (">C");
	i = cn.find(":");
	
	if (i != string::npos)
	{
		if (k != string::npos)
		{
			m = cn.find_first_of("***");
			cName = ">";
			cName += cn.substr (m + 3, i - m - 3);
			cNum = stoi (cn.substr (k + 2, m - k - 2));
		}
		else
		{
			cName = cn.substr (0, i);
		}

		j = cn.find ("-", i + 1);
		if (j != string::npos)
		{
			fP = stoi (cn.substr(i + 1, j - 1));
			eP = stoi (cn.substr(j + 1));
		}
	}
}

